VERSION 5.00
Begin VB.UserControl range 
   ClientHeight    =   720
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   5670
   ScaleHeight     =   720
   ScaleWidth      =   5670
   Begin VB.PictureBox picFrame 
      Appearance      =   0  'Flat
      BackColor       =   &H80000000&
      ForeColor       =   &H80000008&
      Height          =   495
      Left            =   15
      ScaleHeight     =   465
      ScaleWidth      =   5625
      TabIndex        =   0
      Top             =   0
      Width           =   5655
      Begin VB.PictureBox picLeft 
         Appearance      =   0  'Flat
         BackColor       =   &H80000006&
         FillStyle       =   0  'Solid
         ForeColor       =   &H80000008&
         Height          =   375
         Left            =   405
         ScaleHeight     =   345
         ScaleWidth      =   225
         TabIndex        =   2
         Top             =   15
         Width           =   255
      End
      Begin VB.PictureBox picRight 
         Appearance      =   0  'Flat
         BackColor       =   &H80000006&
         FillStyle       =   0  'Solid
         ForeColor       =   &H80000008&
         Height          =   375
         Left            =   5145
         ScaleHeight     =   345
         ScaleWidth      =   225
         TabIndex        =   1
         Top             =   15
         Width           =   255
      End
      Begin VB.Line line1 
         BorderColor     =   &H80000003&
         BorderWidth     =   2
         X1              =   645
         X2              =   5145
         Y1              =   105
         Y2              =   105
      End
   End
   Begin VB.Label lblMax 
      Alignment       =   1  'Right Justify
      Caption         =   "Label1"
      Height          =   240
      Left            =   4515
      TabIndex        =   4
      Top             =   510
      Width           =   1140
   End
   Begin VB.Label lblMin 
      Caption         =   "Label1"
      Height          =   285
      Left            =   0
      TabIndex        =   3
      Top             =   495
      Width           =   1140
   End
End
Attribute VB_Name = "range"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit
Dim m_Range As Integer
Dim m_RangeLeft As Integer
Dim m_RangeRight As Integer

Const m_Width = 255

Event Changed(Left As Integer, Right As Integer)

Public Property Get Range() As Integer
    Range = m_Range
End Property

Public Property Let Range(ByVal New_Range As Integer)
    m_Range = New_Range
    Calculate
End Property

Public Property Get RangeLeft() As Integer
    RangeLeft = m_RangeLeft
End Property

Public Property Get RangeRight() As Integer
    RangeRight = m_RangeRight
End Property

'This handles all movements of the left 'thumb'
Private Sub picLeft_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    'Ignore all but left button moves
    If Button <> vbLeftButton Then Exit Sub
    
    If picFrame.Left < X + picLeft.Left Then
        ' we're ok on the left side
        If picLeft.Left < picRight.Left - m_Width Or X < 0 Then
            'we are moving somewhere between the left and right sides
            picLeft.Move X + picLeft.Left
            line1.X1 = picLeft.Left + picLeft.Width
        Else
            'We are too far right, so butt it up against the right side.
            picLeft.Move picRight.Left - m_Width
            line1.X1 = picRight.Left - m_Width
        End If
    Else
        ' we are too far left, so butt it up against the left side
        picLeft.Move 0
        line1.X1 = picLeft.Left + picLeft.Width
    End If
    Calculate
    RaiseEvent Changed(Me.RangeLeft, Me.RangeRight)
End Sub

'This handles all movements of the right 'thumb'
Private Sub picRight_MouseMove(Button As Integer, Shift As Integer, _
                                X As Single, Y As Single)
    'Ignore all but left button moves
    If Button <> vbLeftButton Then Exit Sub
    
    ' check to make sure that we are within the borders
    If picFrame.Left + picFrame.Width > X + picRight.Left + picRight.Width Then
        If picRight.Left > picLeft.Left + picLeft.Width Or X > 0 Then
            'we are moving somewhere between the left and right sides
            picRight.Move X + picRight.Left
        Else
            'We are too far left, so butt it against the left side
            picRight.Move picLeft.Left + picLeft.Width
        End If
    Else ' we are too far right
        picRight.Move picFrame.Width - m_Width
    End If
    
    'now adjust the right side of the line
    line1.X2 = picRight.Left
    Calculate
    RaiseEvent Changed(Me.RangeLeft, Me.RangeRight)
End Sub
Private Sub Calculate()
   Dim curLeft As Double
   Dim curRight As Double
   Dim absRange As Double
   
   absRange = picFrame.Width - (2 * m_Width)
   
   curLeft = picLeft.Left
   curRight = picRight.Left - m_Width
   
   m_RangeLeft = curLeft / absRange * m_Range
   m_RangeRight = curRight / absRange * m_Range
   If m_RangeRight > m_Range Then m_RangeRight = m_Range 'corrects a small bug
   lblMin.Caption = m_RangeLeft
   lblMax.Caption = m_RangeRight
End Sub

Private Sub UserControl_Initialize()
    'Position and size the left 'Thumb' on the left of the bar
    picLeft.Left = 0
    picLeft.Width = m_Width
    picLeft.Top = 0
    picLeft.Height = picFrame.Height

    'Position and size the right 'Thumb' on the right of the bar
    picRight.Left = picFrame.Width - picRight.Width
    picRight.Width = m_Width
    picRight.Top = 0
    picRight.Height = picFrame.Height
    
    'Position and size the line between the thumbs and in the middle
    line1.X1 = picLeft.Width
    line1.X2 = picRight.Left
    line1.Y1 = picFrame.Height / 2
    line1.Y2 = line1.Y1
    
    'Default Range is 100
    Me.Range = 100
End Sub


